(function(){

if (typeof XWiki == "undefined") {
   XWiki = new Object();
}

if (typeof XWiki.index == "undefined") {
   XWiki.index = new Object();
}

var mimetypes = {
  "image/svg"                     : { "src" : "../../../resources/icons/silk/vector.png", "alt" : "SVG", "title" : "SVG" },
  "application/svg+xml"           : { "src" : "../../../resources/icons/silk/vector.png", "alt" : "SVG", "title" : "SVG" },
  "text/plain"                    : { "src" : "../../../resources/icons/silk/page_white_text.png", "alt" : "Texto", "title" : "Texto"},
  "text/html"                     : { "src" : "../../../resources/icons/silk/html.png", "alt" : "HTML", "title" : "HTML"},
  "text/css"                      : { "src" : "../../../resources/icons/silk/css.png", "alt" : "CSS", "title" : "CSS" },
  "application/xml"               : { "src" : "../../../resources/icons/silk/page_white_code.png", "alt" : "XML", "title" : "XML" },
  "application/pdf"               : { "src" : "../../../resources/icons/silk/page_white_acrobat.png", "alt" : "PDF", "title" : "PDF" },
  "application/postscript"        : { "src" : "../../../resources/icons/silk/page_red.png", "alt" : "PS",   "title" : "PS"  },
  "application/msword"            : { "src" : "../../../resources/icons/silk/page_white_word.png", "alt" : "Documento", "title" : "Documento"},
  "application/powerpoint"        : { "src" : "../../../resources/icons/silk/page_white_powerpoint.png", "alt" : "Apresentação", "title" : "Apresentação" },
  "application/x-shockwave-flash" : { "src" : "../../../resources/icons/silk/page_white_flash.png", "alt" : "Flash", "title" : "Flash" },
  "application/x-tar"             : { "src" : "../../../resources/icons/silk/page_white_compressed.png", "alt" : "Arquivo TAR", "title" : "Arquivo TAR" },
  "application/zip"               : { "src" : "../../../resources/icons/silk/page_white_zip.png", "alt" : "Arquivo ZIP", "title" : "Arquivo ZIP" },
  "application/x-gzip"            : { "src" : "../../../resources/icons/silk/page_white_compressed.png", "alt" : "Arquivo GZ", "title" : "Arquivo GZ"  },
  "application/java-archive"      : { "src" : "../../../resources/icons/silk/cup.png", "alt" : "Arquivo JAR", "title" : "Arquivo JAR" }
};

/**
 * JavasScript equivalent of the #mimetype macro.
 * Returns a 20px * 20px image (as an element) corresponding to the passed mimetype.
 * First lookup if the type is in the mimetypes object above, then handles some other cases (starts/end with, etc.)
 * This function should be cleaned at the same time the mimetype images and macro are.
 */
function getMimeTypeImage(type) {
  var image = undefined;
  if (mimetypes[type]) {
    image = new Element('img',{'src':mimetypes[type].src,'alt':mimetypes[type].alt,'title':mimetypes[type].title});
  }
  else if(type.match(/^image\//)) {
    image = new Element('img', {'src':"../../../resources/icons/silk/picture.png", 'alt':"Imagem", 'title': "Imagem"});
  }
  else if(type.match(/^text\//)) {
    image = new Element('img', {'src':"../../../resources/icons/silk/page_white_text.png", 'alt':"Texto", 'title': "Texto"});
  }
  else if(type.match(/^audio\//)){
    image = new Element('img', {'src':"../../../resources/icons/silk/music.png", 'alt':"Audio", 'title': "Audio"});
  }
  else if(type.match(/^video\//)){
    image = new Element('img', {'src':"../../../resources/icons/silk/film.png", 'alt':"Vídeo", 'title': "Vídeo"});
  }
  else if(type=="application/octet-stream") {
    if (type.match(/\.xls$/)) {
      image = new Element('img', {'src':"../../../resources/icons/silk/page_white_excel.png", 'alt':"Planilha", 'title': "Planilha"});
    }
    else if (type.match(/\.bz$/)) {
      image = new Element('img', {'src':"../../../resources/icons/silk/page_white_compressed.png", 'alt':"Arquivo BZ", 'title': "Arquivo BZ"});
    }
    else if (type.match(/\.tgz$/)) {
      image = new Element('img', {'src':"../../../resources/icons/silk/page_white_compressed.png", 'alt':"Arquivo GZ", 'title': "Arquivo GZ"});
    }
    else if (type.match(/\.rar$/)) {
      image = new Element('img', {'src':"../../../resources/icons/silk/page_white_compressed.png", 'alt':"Arquivo RAR", 'title': "Arquivo RAR"});
    }
    else if (type.match(/\.(odt|odp|odf|ods|sxw|stw)$/)) {
      image = new Element('img', {'src':"../../../resources/icons/silk/page.png", 'alt':"Documento Office", 'title': "Documento Office"});
    }
  } 
  else if (type.match(/^application\//)) {
    image = new Element('img', {'src':"../../../resources/icons/silk/cog.png", 'alt':"Executável Windows", 'title': "Executável Windows"});
  }
  if (typeof image == "undefined") {
    image = new Element('img', {'src': "../../../resources/icons/silk/page_white.png", 'alt':"Anexo", 'title': "Anexo"});
  }
  image.style.width = '16px';
  image.style.height = '16px';
  return image;
}

XWiki.index.displayAttachmentEntry = function (row, i, table) {
  var inaccessibleDocs = false;
  if(row.acclev == true) {
    var fileLink = new Element('a', {'href' : row.fileurl}).update(row.filename);
    var tr = new Element('tr').update(new Element('td').update(fileLink));
    var pageLink = new Element('a', {'href' : row.url}).update(row.page);
    tr.appendChild(new Element('td', {'class' : 'pagename'}).update(pageLink));
    var spaceLink = new Element('a', {'href' : row.spaceurl}).update(row.space);
    tr.appendChild(new Element('td', {'class' : 'spacename'}).update(spaceLink));
    tr.appendChild(new Element('td').update(row.date));
    var aa = new Element('a', {'href' : row.authorurl}).update(row.authorname);
    tr.appendChild(new Element('td').update(aa));
    var type = new Element('td').update(getMimeTypeImage(row.type));
    tr.appendChild(type);
    return tr;
  } else {
    var tr = new Element('tr');
    var page = row.fullname;

    var td1 = new Element('td').update("unavailable");
    var td2 = new Element('td', {'class' : 'pagename'}).update(page + "*");
    var td3 = new Element('td').update(" ");
    var td4 = new Element('td').update(" ");
    var td5 = new Element('td').update(" ");
    var td6 = new Element('td').update(" ");
    tr.appendChild(td1);
    tr.appendChild(td2);
    tr.appendChild(td3);
    tr.appendChild(td4);
    tr.appendChild(td5);
    tr.appendChild(td6);
    $('inaccessibleDocsMessage').removeClassName('hidden');
    return tr;
  }
}

})();

